<template>
  <RequestCertificatePage
    ref="requestCertificatePage"
    certificate-type="functional"
    :certificate-request-body-getter="getCertificateRequestBody"
    :start-over-extra-steps="reset"
  >
    <v-row v-for="idx in mailAddressesCount" :key="idx" dense>
      <v-col>
        <v-text-field
          v-model="requestCertificatePage.request.emailAddresses[idx - 1]"
          prepend-icon="fas fa-envelope"
          :label="$t('request.functional.steps.emailAddresses.emailAddressTextFieldLabel')"
          :rules="[validateEmailAddress]"
          :onblur="validateForm"
        >
          <template #append>
            <v-btn
              v-if="mailAddressesCount > 1"
              icon="fas fa-minus"
              color="red"
              size="x-small"
              :tabindex="idx"
              @click="
                mailAddressesCount--;
                requestCertificatePage.request.emailAddresses.splice(idx - 1, 1);
                validateForm();
              "
            ></v-btn>
          </template>
        </v-text-field>
      </v-col>
    </v-row>
    <v-row dense>
      <v-col class="text-center">
        <v-btn color="secondary" @click="mailAddressesCount++">
          <div class="d-block d-sm-none">
            <icon-with-text icon="fas fa-plus">
              {{ $t("request.functional.steps.emailAddresses.addAnotherButtonShort") }}</icon-with-text
            >
          </div>
          <div class="d-none d-sm-block">
            <icon-with-text icon="fas fa-plus">
              {{ $t("request.functional.steps.emailAddresses.addAnotherButton") }}</icon-with-text
            >
          </div>
        </v-btn>
      </v-col>
    </v-row>
  </RequestCertificatePage>
</template>

<script lang="ts">
import { defineComponent, Ref, ref } from "vue";
import RequestCertificatePage, {
  RequestCertificatePageData,
  RequestCertificateSubPage,
} from "@/components/RequestCertificatePage.vue";
import { store } from "@/ts/common";
import IconWithText from "@/components/IconWithText.vue";

export default defineComponent({
  components: { IconWithText, RequestCertificatePage },
  setup() {
    return {
      store,
      requestCertificatePage: ref() as Ref<RequestCertificatePageData>,
    };
  },
  data() {
    return {
      mailAddressesCount: 1,
    };
  },
  mounted() {
    this.reset();
  },
  methods: {
    reset: function () {
      this.requestCertificatePage.subPage = RequestCertificateSubPage.Request;
      this.requestCertificatePage.request.formValid = false;
    },
    getCertificateRequestBody: function () {
      return {
        emails: this.requestCertificatePage.request.emailAddresses,
      };
    },
    validateForm: function () {
      if (this.requestCertificatePage.$refs?.emailAddressesForm) {
        this.requestCertificatePage.$refs?.emailAddressesForm.validate();
      }
    },
    validateEmailAddress: function (inputToValidate: string) {
      // This reduces the array of email addresses to an occurrence count for each email address.
      // The reduce function takes in two parameters:
      // the iteratively updated accumulator and the current element of the array being processed.
      // If the current email address already exists as a key in the accumulator,
      // the value (count) for that key is increased by 1.
      // If it does not exist yet, it is added with a value (count) of 1.
      const emailAddressesCounts = this.requestCertificatePage.request.emailAddresses.reduce<Record<string, number>>(
        (accumulator, current) => ({ ...accumulator, [current]: (accumulator[current] || 0) + 1 }),
        {}
      );

      let errorMessage = null;
      if (!inputToValidate) {
        errorMessage = this.$t("request.functional.steps.emailAddresses.rules.emailAddressEmpty");
      } else if ((inputToValidate.match(/@/g) || []).length !== 1) {
        errorMessage = this.$t(
          "request.functional.steps.emailAddresses.rules.emailAddressDoesNotContainExactlyOneAtSign"
        );
      } else if (inputToValidate.endsWith("@")) {
        errorMessage = this.$t("request.functional.steps.emailAddresses.rules.emailAddressEndsWithAtSign");
      } else if (!/^[\x20-\x7E]*$/.test(inputToValidate)) {
        errorMessage = this.$t("request.functional.steps.emailAddresses.rules.emailAddressContainsNonASCII");
      } else if (/\s+/.test(inputToValidate)) {
        errorMessage = this.$t("request.functional.steps.emailAddresses.rules.emailAddressContainsWhitespace");
      } else if (inputToValidate in emailAddressesCounts && emailAddressesCounts[inputToValidate] > 1) {
        errorMessage = this.$t("request.functional.steps.emailAddresses.rules.emailAddressAlreadyExists");
      }

      // No problem found
      if (!errorMessage) {
        this.requestCertificatePage.request.formValid = true;
        return true;
      }

      this.requestCertificatePage.request.formValid = false;
      return errorMessage;
    },
  },
});
</script>
